defmodule TrixtaAgentsTest do
  use ExUnit.Case
  doctest TrixtaAgents

  setup do
    id = UUID.uuid1()

    agent_plain_map = %{
      "id" => id,
      "name" => "Genèsis Plain",
      "description" => "The Genèsis Plain Agent",
      "current_state" => :initialising
    }

    agent1_plain_map = %{
      "name" => "Genèsis One Plain",
      "description" => "The Genèsis One Plain Agent",
      "current_state" => :initialising
    }

    agent = %TrixtaAgents.Agent{
      id: id,
      name: "Genèsis",
      description: "The Genèsis Agent",
      current_state: :initialising
    }

    agent1 = %TrixtaAgents.Agent{
      name: "Genèsis One",
      description: "The Genèsis One Agent",
      current_state: :initialising
    }

    [
      agent_plain_map: agent_plain_map,
      agent1_plain_map: agent1_plain_map,
      agent: agent,
      agent1: agent1
    ]
  end

  test "start_agent without params starts a new agent with defaults" do
    assert {:ok, pid, new_agent} = TrixtaAgents.start_agent()

    assert TrixtaAgents.AgentServer.agent_pid(new_agent.id) == pid
    assert new_agent.id != nil
    assert new_agent.name =~ ~r/^[a-z]+-[a-z]+-[0-9]+/
    assert new_agent.description =~ ~r/.+/
    assert new_agent.current_state == :initialising
  end

  test "start_agent starts a new agent with given state plain map", %{
    agent_plain_map: agent_plain_map
  } do
    assert {:ok, pid, new_agent} = TrixtaAgents.start_agent(agent_plain_map)

    assert TrixtaAgents.AgentServer.agent_pid(new_agent.id) == pid
    assert new_agent.id != nil
    assert new_agent.id == agent_plain_map["id"]
    assert new_agent.name == "Genèsis Plain"
    assert new_agent.description == "The Genèsis Plain Agent"
    assert new_agent.current_state == :initialising
  end

  test "start_agent starts a new agent with given state struct", %{agent: agent} do
    assert {:ok, pid, new_agent} = TrixtaAgents.start_agent(agent)

    assert TrixtaAgents.AgentServer.agent_pid(new_agent.id) == pid
    assert new_agent.id != nil
    assert new_agent.id == agent.id
    assert new_agent.name == "Genèsis"
    assert new_agent.description == "The Genèsis Agent"
    assert new_agent.current_state == :initialising
  end

  test "start_agent without an ID starts a new agent with given state plain map and autogenerated ID",
       %{
         agent1_plain_map: agent1_plain_map
       } do
    assert {:ok, pid, new_agent} = TrixtaAgents.start_agent(agent1_plain_map)

    assert TrixtaAgents.AgentServer.agent_pid(new_agent.id) == pid
    assert new_agent.id != nil
    assert new_agent.name == "Genèsis One Plain"
    assert new_agent.description == "The Genèsis One Plain Agent"
    assert new_agent.current_state == :initialising
  end

  test "start_agent without an ID starts a new agent with given state struct and autogenerated ID",
       %{
         agent1: agent1
       } do
    assert {:ok, pid, new_agent} = TrixtaAgents.start_agent(agent1)

    assert TrixtaAgents.AgentServer.agent_pid(new_agent.id) == pid
    assert new_agent.id != nil
    assert new_agent.name == "Genèsis One"
    assert new_agent.description == "The Genèsis One Agent"
    assert new_agent.current_state == :initialising
  end

  test "stop_agent stops a given agent", %{agent: agent} do
    assert {:ok, pid, agent} = TrixtaAgents.start_agent(agent)
    assert TrixtaAgents.stop_agent(agent.id) == :ok
    assert TrixtaAgents.AgentServer.agent_pid(agent.id) == nil

    # Now terminate the agent so that it doesn't interfere with other tests:
    TrixtaAgents.terminate_agent(agent.id)
  end

  test "terminate_agent terminates a named agent", %{agent: agent} do
    assert {:ok, pid, agent} = TrixtaAgents.start_agent(agent)
    assert TrixtaAgents.terminate_agent(agent.id) == :ok
    assert TrixtaAgents.AgentServer.agent_pid(agent.id) == nil
  end
end
